function [ s ] = updateDelta( z,phi,q,f,maximize )
%UPDATES Summary of this function goes here
%   Detailed explanation goes here

if(nargin==4)
    maximize=0;
    dat=[];
    prms=[];
end;

tau=.01;
n=size(z,1);
v=tau+phi*sum(f.^2);
m=(phi./v).*(z*f');
% p=(q.*sqrt(tau))./(sqrt(2*pi)*(1-q).*normpdf(m.^2,0,v)+q.*sqrt(tau));
p=q.*sqrt(tau./v).*exp((phi.*(z*f')).^2./(2*v));
p=p./((1-q)+p);
s=zeros(n,1);
if(maximize)
    for(j=1:size(z,1)) 
        znm(j)=normlike([0 1/sqrt(phi(j))],z(j,:));
        nznm(j)=normlike([0 1/sqrt(phi(j))],z(j,:)-m(j)*f);
        zfpr(j)=-log(1-q(j)); 
        nzfpr(j)=-log(q(j).*normpdf(s(j),0,1/sqrt(.01)));
    end;
%     nzr=find(p.*normpdf(m,m,1./sqrt(v))>1-p);
%     s(nzr)=m(nzr);
    nz=find(nznm+nzfpr<znm+zfpr);
    s(nz)=m(nz);
else;
    nzr=find(rand(n,1)<p);
    s(nzr)=normrnd(m(nzr),1./sqrt(v(nzr)));
end;

