function [ dat ] = processProteomics( dat )
%PROCESSPROTEOMICS Summary of this function goes here
%   Detailed explanation goes here
dat.xpr(dat.xpr<.01)=NaN;
dat.xpr=log(dat.xpr);

kp=find(sum(isnan(dat.xpr),2)==0);
dat.xpr=dat.xpr-repmat(mean(dat.xpr(kp,:)),size(dat.xpr,1),1);

%%% clear outliers
[p n]=size(dat.xpr);
for(count=1:2)
    cdt=standardize(dat.xpr,2);
    out=zeros(p,n);
    for(i=1:p)
        out(i,:)=1*(abs(cdt(i,:))>3);
    end;
    cdt(out==1)=NaN;
    dat.xpr(out==1)=NaN;
end;
%%%%%%%%%%%%
%%% set missing data to row mean
for(i=1:size(dat.xpr,1))
    dat.xpr(i,isnan(dat.xpr(i,:)))=nanmean(dat.xpr(i,:));
end;


end

